class KDockWidget

# class KDockWidget | Floatable widget that can be dragged around with the mouse and encapsulate the actual widgets (and member of the dockwidget class set). More...
Definition | `#include <kdockwidget.h>`
Inherits | QWidget (qt) [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum DockPosition { DockNone = 0, DockTop = 0x0001, DockLeft = 0x0002, DockRight = 0x0004, DockBottom = 0x0008, DockCenter = 0x0010, DockDesktop= 0x0020, DockToSpecialSites=0x0040, DockCorner = DockTop | DockLeft | DockRight | DockBottom, DockFullSite = DockCorner | DockCenter, DockFullDocking = DockFullSite | DockDesktop }

#### Public Methods

- KDockWidget ( KDockManager* dockManager, const char* name, const QPixmap &pixmap, QWidget* parent = 0L, const QString& strCaption = QString::null, const QString& strTabPageLabel = QString::fromLatin1( " " ), WFlags f = 0)
- virtual ~KDockWidget ()
- KDockWidget* manualDock ( KDockWidget* target, DockPosition dockPos, int spliPos = 50, QPoint pos = QPoint(0,0), bool check = false, int tabIndex = -1)
- void setEnableDocking ( int pos )
- int enableDocking () const
- void setDockSite ( int pos )
- int dockSite () const
- void setWidget ( QWidget* w)
- QWidget* getWidget () const
- void setHeader ( KDockWidgetAbstractHeader* ah)
- void makeDockVisible ()
- bool mayBeHide () const
- bool mayBeShow () const
- KDockManager* dockManager () const
- void setToolTipString (const QString& ttStr)
- const QString& toolTipString () const
- bool isDockBackPossible () const
- void setTabPageLabel ( const QString& label)
- const QString& tabPageLabel () const
- virtual bool event ( QEvent * )
- virtual void show ()
- KDockTabGroup* parentDockTabGroup () const
- QWidget * parentDockContainer () const
- void setDockWindowType (NET::WindowType windowType)
- void setDockWindowTransient (QWidget *parent, bool transientEnabled)
- KDockWidget * findNearestDockWidget (DockPosition pos)

#### Public Slots

- void setForcedFixedWidth (int)
- void setForcedFixedHeight (int)
- void restoreFromForcedFixedSize ()
- int forcedFixedWidth ()
- int forcedFixedHeight ()
- void dockBack ()
- void changeHideShowState ()
- void undock ()
- void toDesktop ( )

#### Signals

- void docking ( KDockWidget* dw, KDockWidget::DockPosition dp)
- void setDockDefaultPos ()
- void headerCloseButtonClicked ()
- void headerDockbackButtonClicked ()
- void iMBeingClosed ()
- void hasUndocked ()

#### Protected Methods

- void updateHeader ()
- void setLatestKDockContainer (QWidget *)
- QWidget * latestKDockContainer ()
- virtual void virtual_hook ( int id, void* data )

#### Protected Slots

- void loseFormerBrotherDockWidget ()
- virtual void paintEvent (QPaintEvent*)
- virtual void mousePressEvent (QMouseEvent*)
- virtual void mouseReleaseEvent (QMouseEvent*)
- virtual void mouseMoveEvent (QMouseEvent*)
- virtual void leaveEvent (QEvent*)

#### Protected Members

- KDockWidget* formerBrotherDockWidget
- DockPosition currentDockPos
- DockPosition formerDockPos
- QString toolTipStr
- QString tabPageTitle

## Detailed Description

Floatable widget that can be dragged around with the mouse and encapsulate the actual widgets (and member of the dockwidget class set).

You just grip the double-lined panel, tear it off its parent widget, drag it somewhere and let it loose. Depending on the position where you leave it, the dockwidget becomes a toplevel window on the desktop (floating mode) or docks to a new widget (dock mode). Note: A KDockWidget can only be docked to a KDockWidget.

If you want to use this kind of widget, your main application window has to be a KDockMainWindow. That is because it has got several additional dock management features, for instance a KDockManager that has an overview over all dockwidgets and and a dockmovemanager (internal class) that handles the dock process.

Usually you create an KDockWidget that covers the actual widget in this way:

     ...
     KDockMainWindow* mainWidget;
     ...
     KDockWidget* dock = 0L;
     dock = mainWidget->createDockWidget( "Any window caption", nicePixmap, 0L, i18n("window caption")); // 0L==no parent
     QWidget* actualWidget = new QWidget( dock);
     dock->setWidget( actualWidget); // embed it
     dock->setToolTipString(i18n("That's me")); // available when appearing as tab page
     ...

See KDockMainWindow how a dockwidget is docked in.

KDockWidget ( KDockManager* dockManager, const char* name, const QPixmap &pixmap, QWidget* parent = 0L, const QString& strCaption = QString::null, const QString& strTabPageLabel = QString::fromLatin1( " " ), WFlags f = 0) | ### KDockWidget

Construct a dockwidget.

Initially, docking to another and docking to this is allowed for every `DockPosition`. It is supposed to be no (tab) group. It will taken under control of its dockmanager.

Parameters:

dockManager | The responsible manager (dock helper)
name | Object instance name
pixmap | An icon (for instance shown when docked centered)
parent | Parent widget
strCaption | Title of the dockwidget window (shown when toplevel)
strTabPageLabel | The title of the tab page (shown when in tab page mode), if it is "", only the icon will be shown, if it is 0L, the label is set to strCaption

~KDockWidget () | ### ~KDockWidget

[virtual]

Destructs a dockwidget.

enum DockPosition { DockNone = 0, DockTop = 0x0001, DockLeft = 0x0002, DockRight = 0x0004, DockBottom = 0x0008, DockCenter = 0x0010, DockDesktop= 0x0020, DockToSpecialSites=0x0040, DockCorner = DockTop | DockLeft | DockRight | DockBottom, DockFullSite = DockCorner | DockCenter, DockFullDocking = DockFullSite | DockDesktop } | ### DockPosition

The possible positions where a dockwidget can dock to another dockwidget

KDockWidget* manualDock ( KDockWidget* target, DockPosition dockPos, int spliPos = 50, QPoint pos = QPoint(0,0), bool check = false, int tabIndex = -1) | ### manualDock

This is a key method of this class! Use it to dock dockwidgets to another dockwidget at the right position within its KDockMainWindow or a toplevel dockwidget.

If the target is null, it will become a toplevel dockwidget at position pos; Note: Docking to another dockwidget means exactly: A new parent dockwidget will be created, that replaces the target dockwidget and contains another single helper widget (tab widget or panner) which contains both dockwidgets, this and the target dockwidget. So consider parent<->child relationships change completely during such actions.

Parameters:

target | The dockwidget to dock to
dockPos | One of the DockPositions this is going to dock to
spliPos | The split relation (in percent, or percent*100 in high resolution) between both dockwidgets, target and this
pos | The dock position, mainly of interest for docking to the desktop (as toplevel dockwidget)
check | Only for internal use;
tabIndex | The position index of the tab widget (when in tab page mode), -1 (default) means append

Returns: result The group dockwidget that replaces the target dockwidget and will be grandparent of target and `this`.

void setEnableDocking ( int pos ) | ### setEnableDocking

Specify where it is either possible or impossible for this to dock to another dockwidget.

Parameters:

pos | An OR'ed set of `DockPositions`

int enableDocking () | ### enableDocking

[const]

Returns: Where it is either possible or impossible for this to dock to another dockwidget (an OR'ed set of DockPositions).

void setDockSite ( int pos ) | ### setDockSite

Specify where it is either possible or impossible for another dockwidget to dock to this.

Parameters:

pos | An OR'ed set of `DockPositions`

int dockSite () | ### dockSite

[const]

Returns: There it is either possible or impossible for another dockwidget to dock to this (an OR'ed set of `DockPositions`).

void setWidget ( QWidget* w) | ### setWidget

Sets the embedded widget.

A QLayout takes care about proper resizing, automatically.

Parameters:

w | The pointer to the dockwidget's child widget.

QWidget* getWidget () | ### getWidget

[const]

Get the embedded widget.

Returns: The pointer to the dockwidget's child widget, 0L if there's no such child.

void setHeader ( KDockWidgetAbstractHeader* ah) | ### setHeader

Sets the header of this dockwidget.

A QLayout takes care about proper resizing, automatically. The header contains the drag panel, the close button and the stay button.

Parameters:

ah | A base class pointer to the dockwidget header

void makeDockVisible () | ### makeDockVisible

Normally it simply shows the dockwidget.

But additionally, if it is docked to a tab widget (`DockCenter`), it is set as the active (visible) tab page.

bool mayBeHide () | ### mayBeHide

[const]

There are reasons that it's impossible:

- It is a (tab) group.
- It is already invisible ;-)
- The parent of this is the KDockMainWindow.
- It isn't able to dock to another widget.

Returns: If it may be possible to hide this.

bool mayBeShow () | ### mayBeShow

[const]

- It is a (tab) group.
- It is already visible ;-)
- The parent of this is the `KDockMainWindow`.

Returns: If it may be possible to show this. There are reasons that it's impossible:

KDockManager* dockManager () | ### dockManager

[const]

Returns: The dockmanager that is responsible for this.

void setToolTipString (const QString& ttStr) | ### setToolTipString

Stores a string for a tooltip.

That tooltip string has only a meaning when this dockwidget is shown as tab page. In this case the tooltip is shown when one holds the mouse cursor on the tab page header. Such tooltip will for instance be useful, if you use only icons there. Note: Setting an empty string switches the tooltip off.

Parameters:

ttStr | A string for the tooltip on the tab.

const QString& toolTipString () | ### toolTipString

[const]

Returns: The tooltip string being shown on the appropriate tab page header when in dock-centered mode.

bool isDockBackPossible () | ### isDockBackPossible

[const]

Returns: result `true`, if a dockback is possible, otherwise `false`.

void setTabPageLabel ( const QString& label) | ### setTabPageLabel

Sets a string that is used for the label of the tab page when in tab page mode

Parameters:

label | The new tab page label.

const QString& tabPageLabel () | ### tabPageLabel

[const]

Returns: A string that is used for the label of the tab page when in tab page mode.

bool event ( QEvent * ) | ### event

[virtual]

Catches and processes some QWidget events that are interesting for dockwidgets.

void show () | ### show

[virtual]

Add dockwidget management actions to QWidget::show.

KDockTabGroup* parentDockTabGroup () | ### parentDockTabGroup

[const]

Returns: the parent widget of this if it inherits class KDockTabGroup

QWidget * parentDockContainer () | ### parentDockContainer

[const]

void setDockWindowType (NET::WindowType windowType) | ### setDockWindowType

Sets the type of the dock window

Parameters:

windowType | is type of dock window

void setDockWindowTransient (QWidget *parent, bool transientEnabled) | ### setDockWindowTransient

Sets the type of the dock window

Parameters:

windowType | is type of dock window

KDockWidget * findNearestDockWidget (DockPosition pos) | ### findNearestDockWidget

Lookup the nearest dockwidget docked left/right/top/bottom to this one or return 0

Parameters:

pos | is the position the wanted widget is docked to this one

void setForcedFixedWidth (int) | ### setForcedFixedWidth

[slot]

subject to changes. It doesn't completely work yet without small hacks from within the calling application (Perhaps KDE 3.1.x oder 3.2 width is in pixel. It only affects a widget, which is placed directly into a horizontal KDockSplitter

void setForcedFixedHeight (int) | ### setForcedFixedHeight

[slot]

subject to changes. It doesn't completely work yet without small hacks from within the calling application (Perhaps KDE 3.1.x oder 3.2 height is in pixel. It only affects a widget, which is placed directly into a vertical KDockSplitter

void restoreFromForcedFixedSize () | ### restoreFromForcedFixedSize

[slot]

int forcedFixedWidth () | ### forcedFixedWidth

[slot]

int forcedFixedHeight () | ### forcedFixedHeight

[slot]

void dockBack () | ### dockBack

[slot]

Docks a dockwidget back to the dockwidget that was the neighbor widget before the current dock position.

void changeHideShowState () | ### changeHideShowState

[slot]

Toggles the visibility state of the dockwidget if it is able to be shown or to be hidden.

void undock () | ### undock

[slot]

Undocks this. It means it becomes a toplevel widget framed by the system window manager. A small panel at the top of this undocked widget gives the possibility to drag it into another dockwidget by mouse (docking).

void toDesktop ( ) | ### toDesktop

[slot]

Docks the widget to the desktop (as a toplevel widget)

void updateHeader () | ### updateHeader

[protected]

Checks some conditions and shows or hides the dockwidget header (drag panel). The header is hidden if:

- the parent widget is the KDockMainWindow
- this is a (tab) group dockwidget
- it is not able to dock to another dockwidget

void setLatestKDockContainer (QWidget *) | ### setLatestKDockContainer

[protected]

QWidget * latestKDockContainer () | ### latestKDockContainer

[protected]

void docking ( KDockWidget* dw, KDockWidget::DockPosition dp) | ### docking

[signal]

Emitted when another dock widget is docking to this.

Parameters:

dw | the dockwidget that is docking to this
dp | the DockPosition where it wants to dock to

void setDockDefaultPos () | ### setDockDefaultPos

[signal]

Signals that the dock default position is set.

void headerCloseButtonClicked () | ### headerCloseButtonClicked

[signal]

Emitted when the close button of the panel (KDockWidgetHeader) has been clicked.

void headerDockbackButtonClicked () | ### headerDockbackButtonClicked

[signal]

Emitted when the dockback button of the panel (KDockWidgetHeader) has been clicked.

void iMBeingClosed () | ### iMBeingClosed

[signal]

Emitted when the widget processes a close event.

void hasUndocked () | ### hasUndocked

[signal]

Emitted when the widget has undocked.

void loseFormerBrotherDockWidget () | ### loseFormerBrotherDockWidget

[protected slots slot]

Does several things here when it has noticed that the former brother widget (closest neighbor) gets lost. The former brother widget is needed for a possible dockback action, to speak with the Beatles: "To get back to where you once belonged" ;-)

void paintEvent (QPaintEvent*) | ### paintEvent

[protected slots virtual slot]

void mousePressEvent (QMouseEvent*) | ### mousePressEvent

[protected slots virtual slot]

void mouseReleaseEvent (QMouseEvent*) | ### mouseReleaseEvent

[protected slots virtual slot]

Reimplemented from QWidget.

void mouseMoveEvent (QMouseEvent*) | ### mouseMoveEvent

[protected slots virtual slot]

void leaveEvent (QEvent*) | ### leaveEvent

[protected slots virtual slot]

Reimplemented from QWidget.

KDockWidget* formerBrotherDockWidget | ### formerBrotherDockWidget

[protected]

DockPosition currentDockPos | ### currentDockPos

[protected]

DockPosition formerDockPos | ### formerDockPos

[protected]

QString toolTipStr | ### toolTipStr

[protected]

QString tabPageTitle | ### tabPageTitle

[protected]

void virtual_hook ( int id, void* data ) | ### virtual_hook

[protected virtual]

Previous side (left,right,top,bottom) where this dockwidget was before a dragging action, none if it wasn't dragged before.

- Author: Max Judin (documentation: Falk Brettschneider).
- Generated: root on macppc.ports.openbsd.org on Sat Sep 6 10:36:37 2003, using kdoc 2.0a54.